# boot.b
# The Bootstrap compiler, Version 2.00

. skipdebug
: breakpoint
. emitlabeldisp
: skipdebug

# numbers

^ ii   # temporary variables
^ ii1

^ minusone
^ minvalue
^ hexdigit 16

# control codes

^ tab
^ cr
^ lf

# digit char

^ zerochar
^ ninechar

# punctuation

^ space
^ bang
^ quote
^ sharp
^ dollar
^ and
^ lparen
^ rparen
^ star
^ plus
^ comma
^ minus
^ dot
^ slash
^ colon
^ semicolon
^ less
^ equal
^ greater
^ query
^ atsign
^ lbracket
^ rbracket
^ hat
^ underscore
^ or
^ squiggle

# lower case

^ lettera
^ letterb
^ letterc
^ letterd
^ lettere
^ letterf
^ letterg
^ letterh
^ letteri
^ letterj
^ letterk
^ letterl
^ letterm
^ lettern
^ lettero
^ letterp
^ letterq
^ letterr
^ letters
^ lettert
^ letteru
^ letterv
^ letterw
^ letterx
^ lettery
^ letterz

# 386 registers
^ eax
^ ecx
^ edx
^ ebx
^ esp
^ ebp
^ esi
^ edi

# numbers
$ 0 - 1 ~ minusone
$ 65536 * 32768 ~ minvalue   # HACK: no exceptions raised on overflow
$  0 ~ ii $  48 ~ hexdigit[ii]
$  1 ~ ii $  49 ~ hexdigit[ii]
$  2 ~ ii $  50 ~ hexdigit[ii]
$  3 ~ ii $  51 ~ hexdigit[ii]
$  4 ~ ii $  52 ~ hexdigit[ii]
$  5 ~ ii $  53 ~ hexdigit[ii]
$  6 ~ ii $  54 ~ hexdigit[ii]
$  7 ~ ii $  55 ~ hexdigit[ii]
$  8 ~ ii $  56 ~ hexdigit[ii]
$  9 ~ ii $  57 ~ hexdigit[ii]
$ 10 ~ ii $  97 ~ hexdigit[ii]
$ 11 ~ ii $  98 ~ hexdigit[ii]
$ 12 ~ ii $  99 ~ hexdigit[ii]
$ 13 ~ ii $ 100 ~ hexdigit[ii]
$ 14 ~ ii $ 101 ~ hexdigit[ii]
$ 15 ~ ii $ 102 ~ hexdigit[ii]

# control codes
$   9 ~ tab
$  13 ~ cr
$  10 ~ lf

# digit character base
$  48 ~ zerochar
$  57 ~ ninechar

# letters
$  97 ~ lettera
$  98 ~ letterb
$  99 ~ letterc
$ 100 ~ letterd
$ 101 ~ lettere
$ 102 ~ letterf
$ 103 ~ letterg
$ 104 ~ letterh
$ 105 ~ letteri
$ 106 ~ letterj
$ 107 ~ letterk
$ 108 ~ letterl
$ 109 ~ letterm
$ 110 ~ lettern
$ 111 ~ lettero
$ 112 ~ letterp
$ 113 ~ letterq
$ 114 ~ letterr
$ 115 ~ letters
$ 116 ~ lettert
$ 117 ~ letteru
$ 118 ~ letterv
$ 119 ~ letterw
$ 120 ~ letterx
$ 121 ~ lettery
$ 122 ~ letterz

# punctuation
$  32 ~ space
$  33 ~ bang
$  34 ~ quote
$  35 ~ sharp
$  36 ~ dollar
$  38 ~ and
$  40 ~ lparen
$  41 ~ rparen
$  42 ~ star
$  43 ~ plus
$  44 ~ comma
$  45 ~ minus
$  46 ~ dot
$  47 ~ slash
$  58 ~ colon
$  59 ~ semicolon
$  60 ~ less
$  61 ~ equal
$  62 ~ greater
$  63 ~ query
$  64 ~ atsign
$  91 ~ lbracket
$  93 ~ rbracket
$  94 ~ hat
$  95 ~ underscore
$ 124 ~ or
$ 126 ~ squiggle

# registers
$ 0 ~ eax
$ 1 ~ ecx
$ 2 ~ edx
$ 3 ~ ebx
$ 4 ~ esp
$ 5 ~ ebp
$ 6 ~ esi
$ 7 ~ edi

# variables

^ argchar
^ temp   # single subroutine level, or return value
^ i      # high level loop variable
^ j      # high level loop variable
^ k      # low level loop variable
^ n      # subroutine argument

# lexical analyzer
^ nxtchar
^ nxttoken

^ idlength
^ idlengthmax     # capacity in number of characters
^ idstring 256

^ nxttokval       # value associated with token
                  # number token -> value of number
                  # identifier   -> symbol table index

# symbol table
^ nameindex       # temporary for searching symbol table
^ eqindex         # temporary for comparing name strings

^ numsym          # number of symbols stored
^ numsymmax       # capacity in number of entries
^ symname  500
^ symvalue 500

^ namepoolsize    # number of bytes stored
^ namepoolmax     # capacity in number of bytes
^ namepool 8192

# code generation
^ csize
^ dsize
^ binval

# number conversion
^ minusflag
# -- unpacked digit arrays
^ decarray 11    # digits from least sig to most sig + sign (1 = negative)
^ hexarray  8    # digits from least sig to most sig

# files
^ fnamelengthmax  # capacity in number of characters
^ srcfname 260
^ incfname 260
^ tgtfname 260
^ lstfname 260

^ srcfile
^ tgtfile
^ lstfile
^ prebinfile # temporary bin file
^ tblfile    # forward reference table file
^ binfile    # raw binary executable code

^ tgtbyte
^ lstchar

# set limit parameters
$ 255 ~ idlengthmax
$ 500 ~ numsymmax
$ 8192 ~ namepoolmax
$ 259 ~ fnamelengthmax

@ parsecommandline

# source file name
$ 0 ~ i

: copysfn

$ srcfname[i] ~ temp
$ temp ~ sysarray[i]
$ i + 1 ~ i

$ temp > 0 ? copysfn

# open for read
$ 0 ~ sysarg1
$ 2 ~ sysfn
@ system
$ sysarg1 ~ srcfile

$ srcfile = minusone ? exitprogram

# target file name
$ 0 ~ i

: copytfn

$ tgtfname[i] ~ temp
$ temp ~ sysarray[i]
$ i + 1 ~ i

$ temp > 0 ? copytfn

# open for write
$ 1 ~ sysarg1
$ 2 ~ sysfn
@ system
$ sysarg1 ~ tgtfile

$ tgtfile = minusone ? exitprogram

# list file name
$ 0 ~ i

: copylfn

$ lstfname[i] ~ temp
$ temp ~ sysarray[i]
$ i + 1 ~ i

$ temp > 0 ? copylfn

# open for write
$ 1 ~ sysarg1
$ 2 ~ sysfn
@ system
$ sysarg1 ~ lstfile

$ lstfile = minusone ? exitprogram

# temporary bin file
$ 0 ~ ii $ dollar ~ sysarray[ii]
$ 1 ~ ii $ dollar ~ sysarray[ii]
$ 2 ~ ii $ zerochar + 1 ~ sysarray[ii]
$ 3 ~ ii $ 0 ~ sysarray[ii]

# open for write
$ 1 ~ sysarg1
$ 2 ~ sysfn
@ system
$ sysarg1 ~ prebinfile

$ prebinfile = minusone ? exitprogram

# forward reference table file
$ 0 ~ ii $ dollar ~ sysarray[ii]
$ 1 ~ ii $ dollar ~ sysarray[ii]
$ 2 ~ ii $ zerochar + 2 ~ sysarray[ii]
$ 3 ~ ii $ 0 ~ sysarray[ii]

# open for write
$ 1 ~ sysarg1
$ 2 ~ sysfn
@ system
$ sysarg1 ~ tblfile

$ tblfile = minusone ? exitprogram

# raw binary executable file
$ 0 ~ ii $ letterb ~ sysarray[ii]
$ 1 ~ ii $ letteri ~ sysarray[ii]
$ 2 ~ ii $ lettern ~ sysarray[ii]
$ 3 ~ ii $ 0 ~ sysarray[ii]

# open for write
$ 1 ~ sysarg1
$ 2 ~ sysfn
@ system
$ sysarg1 ~ binfile

$ binfile = minusone ? exitprogram

@ parse

# close intermediate files
$ prebinfile ~ sysarg1
$ 3 ~ sysfn
@ system
$ tblfile ~ sysarg1
$ 3 ~ sysfn
@ system

# temporary bin file
$ 0 ~ ii $ dollar ~ sysarray[ii]
$ 1 ~ ii $ dollar ~ sysarray[ii]
$ 2 ~ ii $ zerochar + 1 ~ sysarray[ii]
$ 3 ~ ii $ 0 ~ sysarray[ii]
# reopen for read
$ 0 ~ sysarg1
$ 2 ~ sysfn
@ system
$ sysarg1 ~ prebinfile
$ prebinfile = minusone ? exitprogram
# forward reference table file
$ 0 ~ ii $ dollar ~ sysarray[ii]
$ 1 ~ ii $ dollar ~ sysarray[ii]
$ 2 ~ ii $ zerochar + 2 ~ sysarray[ii]
$ 3 ~ ii $ 0 ~ sysarray[ii]
# reopen for read
$ 0 ~ sysarg1
$ 2 ~ sysfn
@ system
$ sysarg1 ~ tblfile

@ finishbin
@ dumpsym

# close files

$ srcfile ~ sysarg1
$ 3 ~ sysfn
@ system

$ tgtfile ~ sysarg1
$ 3 ~ sysfn
@ system

$ lstfile ~ sysarg1
$ 3 ~ sysfn
@ system

$ prebinfile ~ sysarg1
$ 3 ~ sysfn
@ system

$ tblfile ~ sysarg1
$ 3 ~ sysfn
@ system

$ binfile ~ sysarg1
$ 3 ~ sysfn
@ system

: exitprogram

# exit
$ 0 ~ sysfn
@ system

# ===== the main parser

: parse

# initialize symbol table
$ 0 ~ numsym
$ 0 ~ symname[numsym]
$ 0 ~ namepoolsize
$ 0 ~ namepool[namepoolsize]

# initialize code generator
$ 0 ~ csize
$ 0 ~ dsize
@ emitheader

# initialize lexical analyzer
@ getchar
@ gettoken

: mainloop

$ nxttoken = minusone ? exitmainloop

@ parseinstruction

. mainloop

: exitmainloop

@ emittrailer
!

# ===== parse instruction =====

: parseinstruction

$ nxttoken = hat ? parsedclvar
$ nxttoken = atsign ? parsecall
$ nxttoken = dot ? parsegoto
$ nxttoken = query ? parseifgoto
$ nxttoken = colon ? parselabel
$ nxttoken = bang ? parsereturn
$ nxttoken = dollar ? parseload
$ nxttoken = squiggle ? parsestore
$ nxttoken = plus ? parseadd
$ nxttoken = minus ? parsesub
$ nxttoken = star ? parsemult
$ nxttoken = slash ? parsediv
$ nxttoken = and ? parseand
$ nxttoken = or ? parseor
$ nxttoken = less ? parselt
$ nxttoken = equal ? parseeq
$ nxttoken = greater ? parsegt
$ nxttoken = letteri ? parseid
$ nxttoken = zerochar ? parsenum

$ nxttoken ~ tgtbyte
@ outbyte

@ gettoken
!

: parseid
$ nxttokval ~ n @ emitid
@ gettoken
!

: parsenum
$ nxttokval ~ n @ emitdec
@ gettoken
!

# =====
# ^ detected, find name, generate declaration
# =====
: parsedclvar
@ gettoken
$ nxttoken = letteri ? dclvarok
@ error
!
: dclvarok
$ dsize ~ symvalue[nxttokval]

@ gettoken
$ nxttoken = zerochar ? dclarraywithdim

: dclvar1
$ dsize + 4 ~ dsize
!

: dclarraywithdim
$ 4 * nxttokval ~ temp
$ dsize + temp ~ dsize

@ gettoken
!

# =====
# @ detected, find name, generate instruction
# =====
: parsecall
@ gettoken
$ nxttoken = letteri ? callok
@ error
!
: callok
# E8 displ
$ 232 ~ n @ emitdb
$ semicolon ~ tgtbyte @ outbyte
$ letterc ~ tgtbyte @ outbyte
$ lettera ~ tgtbyte @ outbyte
$ letterl ~ tgtbyte @ outbyte
$ letterl ~ tgtbyte @ outbyte
$ space   ~ tgtbyte @ outbyte
$ nxttokval ~ n @ emitid
@ outcrlf
$ nxttokval ~ n @ emitlabeldisp
@ outcrlf

@ gettoken
!

# =====
# . detected, find name, generate instruction
# =====
: parsegoto
@ gettoken
$ nxttoken = letteri ? gotook
@ error
!
: gotook
# E9 displ
$ 233 ~ n @ emitdb
$ semicolon ~ tgtbyte @ outbyte
$ letterj ~ tgtbyte @ outbyte
$ letterm ~ tgtbyte @ outbyte
$ letterp ~ tgtbyte @ outbyte
$ space   ~ tgtbyte @ outbyte
$ nxttokval ~ n @ emitid
@ outcrlf
$ nxttokval ~ n @ emitlabeldisp
@ outcrlf

@ gettoken
!

# =====
# ? detected, find name, generate instructions
# =====
: parseifgoto
@ gettoken
$ nxttoken = letteri ? ifgotook
@ error
!
: ifgotook
# 85 C0
$ 133 ~ n @ emitdb
$ semicolon ~ tgtbyte @ outbyte
$ lettert ~ tgtbyte @ outbyte
$ lettere ~ tgtbyte @ outbyte
$ letters ~ tgtbyte @ outbyte
$ lettert ~ tgtbyte @ outbyte
$ space   ~ tgtbyte @ outbyte
@ emiteax
$ comma   ~ tgtbyte @ outbyte
@ emiteax
@ outcrlf
$ 8 * eax + eax + 192 ~ n @ emitdb
@ outcrlf

# 0F 85 displ
$ 15 ~ n @ emitdb
$ semicolon ~ tgtbyte @ outbyte
$ letterj ~ tgtbyte @ outbyte
$ lettern ~ tgtbyte @ outbyte
$ letterz ~ tgtbyte @ outbyte
$ space   ~ tgtbyte @ outbyte
$ nxttokval ~ n @ emitid
@ outcrlf
$ 133 ~ n @ emitdb
@ outcrlf
$ nxttokval ~ n @ emitlabeldisp
@ outcrlf

@ gettoken
!

# =====
# : detected, find name, generate label
# =====
: parselabel
@ gettoken
$ nxttoken = letteri ? labelok
@ error
!
: labelok
$ csize ~ symvalue[nxttokval]
$ nxttokval ~ n @ emitid
$ colon ~ tgtbyte @ outbyte
@ outcrlf

@ gettoken
!

# =====
# ! detected, generate instruction
# =====
: parsereturn
# C3
$ 195 ~ n @ emitdb
$ semicolon ~ tgtbyte @ outbyte
@ emitreturn
@ outcrlf
@ gettoken
!

# =====
# $ detected, find operand, generate instructions
# =====
: parseload
@ gettoken

@ parseopd

# 8B C1
$ 139 ~ n @ emitdb
$ semicolon  ~ tgtbyte @ outbyte
@ emitmov
$ space ~ tgtbyte @ outbyte
@ emiteax
$ comma ~ tgtbyte @ outbyte
@ emitecx
@ outcrlf
$ 8 * eax + ecx + 192 ~ n @ emitdb
@ outcrlf
!

# =====
# ~ detected, find variable, generate instructions
# =====
: parsestore
@ gettoken
$ nxttoken = letteri ? storeok
@ error
!
: storeok
@ parsevar

# 89 01
$ 137 ~ n @ emitdb
$ semicolon  ~ tgtbyte @ outbyte
@ emitmov
$ space    ~ tgtbyte @ outbyte
$ lbracket ~ tgtbyte @ outbyte
@ emitecx
$ rbracket ~ tgtbyte @ outbyte
$ comma    ~ tgtbyte @ outbyte
@ emiteax
@ outcrlf
$ 8 * eax + ecx ~ n @ emitdb
@ outcrlf
!

# =====
# + detected, find operand, generate instructions
# =====
: parseadd
@ gettoken

@ parseopd

# 03 C1
$ 3 ~ n @ emitdb
$ semicolon  ~ tgtbyte @ outbyte
$ lettera ~ tgtbyte @ outbyte
$ letterd ~ tgtbyte @ outbyte
$ letterd ~ tgtbyte @ outbyte
$ space   ~ tgtbyte @ outbyte
@ emiteax
$ comma   ~ tgtbyte @ outbyte
@ emitecx
@ outcrlf
$ 8 * eax + ecx + 192 ~ n @ emitdb
@ outcrlf
!

# =====
# - detected, find variable, generate instructions
# =====
: parsesub
@ gettoken

@ parseopd

# 2B C1
$ 43 ~ n @ emitdb
$ semicolon  ~ tgtbyte @ outbyte
$ letters ~ tgtbyte @ outbyte
$ letteru ~ tgtbyte @ outbyte
$ letterb ~ tgtbyte @ outbyte
$ space   ~ tgtbyte @ outbyte
@ emiteax
$ comma   ~ tgtbyte @ outbyte
@ emitecx
@ outcrlf
$ 8 * eax + ecx + 192 ~ n @ emitdb
@ outcrlf
!

# =====
# * detected, find variable, generate instructions
# =====
: parsemult
@ gettoken

@ parseopd

# F7 E9
$ 247 ~ n @ emitdb
$ semicolon  ~ tgtbyte @ outbyte
$ letteri ~ tgtbyte @ outbyte
$ letterm ~ tgtbyte @ outbyte
$ letteru ~ tgtbyte @ outbyte
$ letterl ~ tgtbyte @ outbyte
$ space   ~ tgtbyte @ outbyte
@ emitecx
@ outcrlf
$ ecx + 232 ~ n @ emitdb
@ outcrlf
!

# =====
# / detected, find variable, generate instructions
# =====
: parsediv
@ gettoken

@ parseopd

# 99
$ 153 ~ n @ emitdb
$ semicolon  ~ tgtbyte @ outbyte
$ letterc ~ tgtbyte @ outbyte
$ letterd ~ tgtbyte @ outbyte
$ letterq ~ tgtbyte @ outbyte
@ outcrlf

# F7 F9
$ 247 ~ n @ emitdb
$ semicolon  ~ tgtbyte @ outbyte
$ letteri ~ tgtbyte @ outbyte
$ letterd ~ tgtbyte @ outbyte
$ letteri ~ tgtbyte @ outbyte
$ letterv ~ tgtbyte @ outbyte
$ space   ~ tgtbyte @ outbyte
@ emitecx
@ outcrlf
$ ecx + 248 ~ n @ emitdb
@ outcrlf
!

# =====
# & detected, find variable, generate instructions
# =====
: parseand
@ gettoken

@ parseopd

# 23 C1
$ 35 ~ n @ emitdb
$ semicolon  ~ tgtbyte @ outbyte
$ lettera ~ tgtbyte @ outbyte
$ lettern ~ tgtbyte @ outbyte
$ letterd ~ tgtbyte @ outbyte
$ space   ~ tgtbyte @ outbyte
@ emiteax
$ comma   ~ tgtbyte @ outbyte
@ emitecx
@ outcrlf
$ 8 * eax + ecx + 192 ~ n @ emitdb
@ outcrlf
!

# =====
# | detected, find variable, generate instructions
# =====
: parseor
@ gettoken

@ parseopd

# 0B C1
$ 11 ~ n @ emitdb
$ semicolon  ~ tgtbyte @ outbyte
$ lettero ~ tgtbyte @ outbyte
$ letterr ~ tgtbyte @ outbyte
$ space   ~ tgtbyte @ outbyte
@ emiteax
$ comma   ~ tgtbyte @ outbyte
@ emitecx
@ outcrlf
$ 8 * eax + ecx + 192 ~ n @ emitdb
@ outcrlf
!

# =====
# < detected, find variable, generate instructions
# =====
: parselt
@ gettoken

@ parseopd

# 3B C1
$ 59 ~ n @ emitdb
$ semicolon  ~ tgtbyte @ outbyte
@ emitcmp
$ space   ~ tgtbyte @ outbyte
@ emiteax
$ comma   ~ tgtbyte @ outbyte
@ emitecx
@ outcrlf
$ 8 * eax + ecx + 192 ~ n @ emitdb
@ outcrlf

# 0F 9C C0
$ 15 ~ n @ emitdb
$ semicolon  ~ tgtbyte @ outbyte
@ emitset
$ letterl ~ tgtbyte @ outbyte
$ space   ~ tgtbyte @ outbyte
$ lettera ~ tgtbyte @ outbyte
$ letterl ~ tgtbyte @ outbyte
@ outcrlf
$ 156 ~ n @ emitdb
@ outcrlf
$ 192 ~ n @ emitdb
@ outcrlf

# 81 E0 00000001
$ 129 ~ n @ emitdb
$ semicolon  ~ tgtbyte @ outbyte
@ emitand
$ space        ~ tgtbyte @ outbyte
@ emiteax
$ comma        ~ tgtbyte @ outbyte
$ zerochar + 1 ~ tgtbyte @ outbyte
@ outcrlf
$ eax + 224 ~ n @ emitdb
@ outcrlf
$ 1 ~ n @ emitdd
@ outcrlf
!

# =====
# = detected, find variable, generate instructions
# =====
: parseeq
@ gettoken

@ parseopd

# 3B C1
$ 59 ~ n @ emitdb
$ semicolon  ~ tgtbyte @ outbyte
@ emitcmp
$ space ~ tgtbyte @ outbyte
@ emiteax
$ comma ~ tgtbyte @ outbyte
@ emitecx
@ outcrlf
$ 8 * eax + ecx + 192 ~ n @ emitdb
@ outcrlf

# 0F 94 C0
$ 15 ~ n @ emitdb
$ semicolon  ~ tgtbyte @ outbyte
@ emitset
$ lettere ~ tgtbyte @ outbyte
$ space   ~ tgtbyte @ outbyte
$ lettera ~ tgtbyte @ outbyte
$ letterl ~ tgtbyte @ outbyte
@ outcrlf
$ 148 ~ n @ emitdb
@ outcrlf
$ 192 ~ n @ emitdb
@ outcrlf

# 81 E0 00000001
$ 129 ~ n @ emitdb
$ semicolon  ~ tgtbyte @ outbyte
@ emitand
$ space        ~ tgtbyte @ outbyte
@ emiteax
$ comma        ~ tgtbyte @ outbyte
$ zerochar + 1 ~ tgtbyte @ outbyte
@ outcrlf
$ eax + 224 ~ n @ emitdb
@ outcrlf
$ 1 ~ n @ emitdd
@ outcrlf
!

# =====
# > detected, find variable, generate instructions
# =====
: parsegt
@ gettoken

@ parseopd

# 3B C1
$ 59 ~ n @ emitdb
$ semicolon  ~ tgtbyte @ outbyte
@ emitcmp
$ space ~ tgtbyte @ outbyte
@ emiteax
$ comma ~ tgtbyte @ outbyte
@ emitecx
@ outcrlf
$ 8 * eax + ecx + 192 ~ n @ emitdb
@ outcrlf

# 0F 9F C0
$ 15 ~ n @ emitdb
$ semicolon  ~ tgtbyte @ outbyte
@ emitset
$ letterg ~ tgtbyte @ outbyte
$ space   ~ tgtbyte @ outbyte
$ lettera ~ tgtbyte @ outbyte
$ letterl ~ tgtbyte @ outbyte
@ outcrlf
$ 159 ~ n @ emitdb
@ outcrlf
$ 192 ~ n @ emitdb
@ outcrlf

# 81 E0 00000001
$ 129 ~ n @ emitdb
$ semicolon  ~ tgtbyte @ outbyte
@ emitand
$ space        ~ tgtbyte @ outbyte
@ emiteax
$ comma        ~ tgtbyte @ outbyte
$ zerochar + 1 ~ tgtbyte @ outbyte
@ outcrlf
$ eax + 224 ~ n @ emitdb
@ outcrlf
$ 1 ~ n @ emitdd
@ outcrlf
!

# =====
# expecting operand, if valid, generate instructions (load value into register ECX)
# =====
: parseopd
$ nxttoken = zerochar ? foundnumtoken
$ nxttoken = letteri ? foundidtoken
@ error
!

: foundnumtoken
@ parsenumber
!

: foundidtoken
@ parsevar

# 8B 09
$ 139 ~ n @ emitdb
$ semicolon  ~ tgtbyte @ outbyte
@ emitmov
$ space    ~ tgtbyte @ outbyte
@ emitecx
$ comma    ~ tgtbyte @ outbyte
$ lbracket ~ tgtbyte @ outbyte
@ emitecx
$ rbracket ~ tgtbyte @ outbyte
@ outcrlf
$ 8 * ecx + ecx ~ n @ emitdb
@ outcrlf
!

# =====
# operand constant detected, generate instructions
# =====
: parsenumber
# B9 data
$ 184 + ecx ~ n @ emitdb
$ semicolon  ~ tgtbyte @ outbyte
@ emitmov
$ space ~ tgtbyte @ outbyte
@ emitecx
$ comma ~ tgtbyte @ outbyte
$ nxttokval ~ n @ emitdec
@ outcrlf
$ nxttokval ~ n @ emitdd
@ outcrlf

@ gettoken
!

# =====
# operand identifier detected, find subscript, if any, generate instructions (load address into ECX)
# =====
: parsevar
# 8D 8E offset
$ 141 ~ n @ emitdb
$ semicolon  ~ tgtbyte @ outbyte
$ letterl ~ tgtbyte @ outbyte
$ lettere ~ tgtbyte @ outbyte
$ lettera ~ tgtbyte @ outbyte
$ space ~ tgtbyte @ outbyte
@ emitecx
$ comma ~ tgtbyte @ outbyte
$ lbracket ~ tgtbyte @ outbyte
@ emitesi
$ plus     ~ tgtbyte @ outbyte
$ symvalue[nxttokval] ~ n @ emitdec
$ rbracket ~ tgtbyte @ outbyte
$ semicolon ~ tgtbyte @ outbyte
$ nxttokval ~ n @ emitid
@ outcrlf
$ 8 * ecx + esi + 128 ~ n @ emitdb
@ outcrlf
$ symvalue[nxttokval] ~ n @ emitdd
@ outcrlf

@ gettoken
@ parsesubscript
!

# =====
# [ detected, find name, generate instructions
# =====
: parsesubscript
$ nxttoken = lbracket ? subscriptok
!
: subscriptok
@ gettoken
$ nxttoken = letteri ? subscriptidok
@ error
!
: subscriptidok
# 8B 95 displ
$ 139 ~ n @ emitdb
$ semicolon ~ tgtbyte @ outbyte
$ letterm ~ tgtbyte @ outbyte
$ lettero ~ tgtbyte @ outbyte
$ letterv ~ tgtbyte @ outbyte
$ space ~ tgtbyte @ outbyte
@ emitedx
$ comma ~ tgtbyte @ outbyte
$ lbracket ~ tgtbyte @ outbyte
@ emitesi
$ plus     ~ tgtbyte @ outbyte
$ symvalue[nxttokval] ~ n @ emitdec
$ rbracket ~ tgtbyte @ outbyte
$ semicolon ~ tgtbyte @ outbyte
$ nxttokval ~ n @ emitid
@ outcrlf
$ 8 * edx + esi + 128 ~ n @ emitdb
@ outcrlf
$ symvalue[nxttokval] ~ n @ emitdd
@ outcrlf

# C1 E2 02
$ 193 ~ n @ emitdb
$ semicolon  ~ tgtbyte @ outbyte
$ letters      ~ tgtbyte @ outbyte
$ letterh      ~ tgtbyte @ outbyte
$ letterl      ~ tgtbyte @ outbyte
$ space        ~ tgtbyte @ outbyte
@ emitedx
$ comma        ~ tgtbyte @ outbyte
$ zerochar + 2 ~ tgtbyte @ outbyte
@ outcrlf
$ edx + 224 ~ n @ emitdb
@ outcrlf
$ 2 ~ n @ emitdb
@ outcrlf

# 03 CA
$ 3 ~ n @ emitdb
$ semicolon  ~ tgtbyte @ outbyte
$ lettera ~ tgtbyte @ outbyte
$ letterd ~ tgtbyte @ outbyte
$ letterd ~ tgtbyte @ outbyte
$ space   ~ tgtbyte @ outbyte
@ emitecx
$ comma   ~ tgtbyte @ outbyte
@ emitedx
@ outcrlf
$ 8 * ecx + edx + 192 ~ n @ emitdb
@ outcrlf

@ gettoken

$ nxttoken = rbracket ? subscriptendok
!
: subscriptendok
@ gettoken
!

# ===== emit header =====

^ addrpsystem    # address of psystem variable (pointer to System subroutine)
^ addrmonitor    # address of monitor block (arguments to System subroutine)

: emitheader

$ dot          ~ tgtbyte @ outbyte
$ zerochar + 3 ~ tgtbyte @ outbyte
$ zerochar + 8 ~ tgtbyte @ outbyte
$ zerochar + 6 ~ tgtbyte @ outbyte
@ outcrlf

$ dot     ~ tgtbyte @ outbyte
$ letterm ~ tgtbyte @ outbyte
$ lettero ~ tgtbyte @ outbyte
$ letterd ~ tgtbyte @ outbyte
$ lettere ~ tgtbyte @ outbyte
$ letterl ~ tgtbyte @ outbyte
$ space   ~ tgtbyte @ outbyte
$ letterf ~ tgtbyte @ outbyte
$ letterl ~ tgtbyte @ outbyte
$ lettera ~ tgtbyte @ outbyte
$ lettert ~ tgtbyte @ outbyte
@ outcrlf

# == allocate psystem (pointer to System subroutine)

$ dsize ~ addrpsystem

$ dsize + 4 ~ dsize

# == BEGIN monitor block

$ dsize ~ addrmonitor

$ 0 ~ ii $ letters      ~ idstring[ii]
$ 1 ~ ii $ lettery      ~ idstring[ii]
$ 2 ~ ii $ letters      ~ idstring[ii]
$ 3 ~ ii $ letterf      ~ idstring[ii]
$ 4 ~ ii $ lettern      ~ idstring[ii]
$ 5 ~ ii $ 0            ~ idstring[ii]
@ enterid
$ dsize ~ symvalue[nameindex]
$ dsize + 4 ~ dsize

$ 0 ~ ii $ letters      ~ idstring[ii]
$ 1 ~ ii $ lettery      ~ idstring[ii]
$ 2 ~ ii $ letters      ~ idstring[ii]
$ 3 ~ ii $ lettera      ~ idstring[ii]
$ 4 ~ ii $ letterr      ~ idstring[ii]
$ 5 ~ ii $ letterg      ~ idstring[ii]
$ 6 ~ ii $ zerochar + 1 ~ idstring[ii]
$ 7 ~ ii $ 0            ~ idstring[ii]
@ enterid
$ dsize ~ symvalue[nameindex]
$ dsize + 4 ~ dsize

$ 0 ~ ii $ letters      ~ idstring[ii]
$ 1 ~ ii $ lettery      ~ idstring[ii]
$ 2 ~ ii $ letters      ~ idstring[ii]
$ 3 ~ ii $ lettera      ~ idstring[ii]
$ 4 ~ ii $ letterr      ~ idstring[ii]
$ 5 ~ ii $ letterg      ~ idstring[ii]
$ 6 ~ ii $ zerochar + 2 ~ idstring[ii]
$ 7 ~ ii $ 0            ~ idstring[ii]
@ enterid
$ dsize ~ symvalue[nameindex]
$ dsize + 4 ~ dsize

$ 0 ~ ii $ letters      ~ idstring[ii]
$ 1 ~ ii $ lettery      ~ idstring[ii]
$ 2 ~ ii $ letters      ~ idstring[ii]
$ 3 ~ ii $ lettera      ~ idstring[ii]
$ 4 ~ ii $ letterr      ~ idstring[ii]
$ 5 ~ ii $ letterr      ~ idstring[ii]
$ 6 ~ ii $ lettera      ~ idstring[ii]
$ 7 ~ ii $ lettery      ~ idstring[ii]
$ 8 ~ ii $ 0            ~ idstring[ii]
@ enterid
$ dsize ~ symvalue[nameindex]
$ 4 * 4096 ~ temp
$ dsize + temp ~ dsize

# == END monitor block

@ emitpublic
$ space      ~ tgtbyte @ outbyte
$ underscore ~ tgtbyte @ outbyte
@ emitpgm
@ outcrlf

@ emitcode
@ outcrlf

$ underscore ~ tgtbyte @ outbyte
@ emitpgm
$ colon      ~ tgtbyte @ outbyte
@ outcrlf

# magic

$ letterd  ~ tgtbyte @ outbyte
$ letterb  ~ tgtbyte @ outbyte
$ space    ~ tgtbyte @ outbyte
$ zerochar ~ tgtbyte @ outbyte
$ comma    ~ tgtbyte @ outbyte
$ zerochar ~ tgtbyte @ outbyte
$ comma    ~ tgtbyte @ outbyte
$ zerochar ~ tgtbyte @ outbyte
$ comma    ~ tgtbyte @ outbyte
$ zerochar ~ tgtbyte @ outbyte
@ outcrlf

# header size

$ letterd      ~ tgtbyte @ outbyte
$ letterd      ~ tgtbyte @ outbyte
$ space        ~ tgtbyte @ outbyte
$ zerochar + 1 ~ tgtbyte @ outbyte
$ zerochar + 6 ~ tgtbyte @ outbyte
@ outcrlf

# compiler/runtime version

$ letterd      ~ tgtbyte @ outbyte
$ letterd      ~ tgtbyte @ outbyte
$ space        ~ tgtbyte @ outbyte
$ zerochar     ~ tgtbyte @ outbyte
$ zerochar + 0 ~ tgtbyte @ outbyte
$ zerochar + 1 ~ tgtbyte @ outbyte
$ zerochar + 0 ~ tgtbyte @ outbyte
$ zerochar + 0 ~ tgtbyte @ outbyte
$ letterh      ~ tgtbyte @ outbyte
@ outcrlf

# code size

$ letterd ~ tgtbyte @ outbyte
$ letterd ~ tgtbyte @ outbyte
$ space   ~ tgtbyte @ outbyte
$ letterc ~ tgtbyte @ outbyte
$ letters ~ tgtbyte @ outbyte
$ letteri ~ tgtbyte @ outbyte
$ letterz ~ tgtbyte @ outbyte
$ lettere ~ tgtbyte @ outbyte
@ outcrlf

# data size

$ letterd ~ tgtbyte @ outbyte
$ letterd ~ tgtbyte @ outbyte
$ space   ~ tgtbyte @ outbyte
$ letterd ~ tgtbyte @ outbyte
$ letters ~ tgtbyte @ outbyte
$ letteri ~ tgtbyte @ outbyte
$ letterz ~ tgtbyte @ outbyte
$ lettere ~ tgtbyte @ outbyte
@ outcrlf

# start of code

$ 0 ~ ii $ dollar ~ idstring[ii]
$ 1 ~ ii $ dollar ~ idstring[ii]
$ 2 ~ ii $ 0      ~ idstring[ii]
@ enterid

# E9 displ
$ 233 ~ n @ emitdb
$ semicolon ~ tgtbyte @ outbyte
$ letterj ~ tgtbyte @ outbyte
$ letterm ~ tgtbyte @ outbyte
$ letterp ~ tgtbyte @ outbyte
$ space   ~ tgtbyte @ outbyte
$ nameindex ~ n @ emitid
@ outcrlf
$ nameindex ~ n @ breakpoint # @ emitlabeldisp
@ outcrlf

$ 0 ~ ii $ letters      ~ idstring[ii]
$ 1 ~ ii $ lettery      ~ idstring[ii]
$ 2 ~ ii $ letters      ~ idstring[ii]
$ 3 ~ ii $ lettert      ~ idstring[ii]
$ 4 ~ ii $ lettere      ~ idstring[ii]
$ 5 ~ ii $ letterm      ~ idstring[ii]
$ 6 ~ ii $ 0            ~ idstring[ii]
@ enterid
$ csize ~ symvalue[nameindex]

$ nameindex ~ n @ emitid
$ colon      ~ tgtbyte @ outbyte
@ outcrlf

# 55
$ 80 + ebp ~ n @ emitdb
$ semicolon  ~ tgtbyte @ outbyte
$ letterp    ~ tgtbyte @ outbyte
$ letteru    ~ tgtbyte @ outbyte
$ letters    ~ tgtbyte @ outbyte
$ letterh    ~ tgtbyte @ outbyte
$ space      ~ tgtbyte @ outbyte
$ lettere    ~ tgtbyte @ outbyte
$ letterb    ~ tgtbyte @ outbyte
$ letterp    ~ tgtbyte @ outbyte
@ outcrlf

# 8B EC
$ 139 ~ n @ emitdb
$ semicolon  ~ tgtbyte @ outbyte
$ letterm ~ tgtbyte @ outbyte
$ lettero ~ tgtbyte @ outbyte
$ letterv ~ tgtbyte @ outbyte
$ space   ~ tgtbyte @ outbyte
$ lettere ~ tgtbyte @ outbyte
$ letterb ~ tgtbyte @ outbyte
$ letterp ~ tgtbyte @ outbyte
$ comma   ~ tgtbyte @ outbyte
$ lettere ~ tgtbyte @ outbyte
$ letters ~ tgtbyte @ outbyte
$ letterp ~ tgtbyte @ outbyte
@ outcrlf
$ 8 * ebp + esp + 192 ~ n @ emitdb
@ outcrlf

# 8D 8E offset
$ 141 ~ n @ emitdb
$ semicolon  ~ tgtbyte @ outbyte
$ letterl ~ tgtbyte @ outbyte
$ lettere ~ tgtbyte @ outbyte
$ lettera ~ tgtbyte @ outbyte
$ space   ~ tgtbyte @ outbyte
@ emitecx
$ comma   ~ tgtbyte @ outbyte
$ lbracket ~ tgtbyte @ outbyte
@ emitesi
$ plus     ~ tgtbyte @ outbyte
$ addrmonitor ~ n @ emitdec
$ rbracket ~ tgtbyte @ outbyte
@ outcrlf
$ 8 * ecx + esi + 128 ~ n @ emitdb
@ outcrlf
$ addrmonitor ~ n @ emitdd
@ outcrlf

# 51
$ 80 + ecx ~ n @ emitdb
$ semicolon  ~ tgtbyte @ outbyte
$ letterp ~ tgtbyte @ outbyte
$ letteru ~ tgtbyte @ outbyte
$ letters ~ tgtbyte @ outbyte
$ letterh ~ tgtbyte @ outbyte
$ space   ~ tgtbyte @ outbyte
@ emitecx
@ outcrlf

# FF 96 offset
$ 255 ~ n @ emitdb
$ semicolon  ~ tgtbyte @ outbyte
$ letterc ~ tgtbyte @ outbyte
$ lettera ~ tgtbyte @ outbyte
$ letterl ~ tgtbyte @ outbyte
$ letterl ~ tgtbyte @ outbyte
$ space   ~ tgtbyte @ outbyte
$ letterd ~ tgtbyte @ outbyte
$ letterw ~ tgtbyte @ outbyte
$ lettero ~ tgtbyte @ outbyte
$ letterr ~ tgtbyte @ outbyte
$ letterd ~ tgtbyte @ outbyte
$ space   ~ tgtbyte @ outbyte
$ letterp ~ tgtbyte @ outbyte
$ lettert ~ tgtbyte @ outbyte
$ letterr ~ tgtbyte @ outbyte
$ lbracket ~ tgtbyte @ outbyte
@ emitesi
$ plus     ~ tgtbyte @ outbyte
$ addrpsystem ~ n @ emitdec
$ rbracket ~ tgtbyte @ outbyte
@ outcrlf
$ 144 + esi ~ n @ emitdb
@ outcrlf
$ addrpsystem ~ n @ emitdd
@ outcrlf

# 8B E5
$ 139 ~ n @ emitdb
$ semicolon  ~ tgtbyte @ outbyte
$ letterm ~ tgtbyte @ outbyte
$ lettero ~ tgtbyte @ outbyte
$ letterv ~ tgtbyte @ outbyte
$ space   ~ tgtbyte @ outbyte
$ lettere ~ tgtbyte @ outbyte
$ letters ~ tgtbyte @ outbyte
$ letterp ~ tgtbyte @ outbyte
$ comma   ~ tgtbyte @ outbyte
$ lettere ~ tgtbyte @ outbyte
$ letterb ~ tgtbyte @ outbyte
$ letterp ~ tgtbyte @ outbyte
@ outcrlf
$ 8 * esp + ebp + 192 ~ n @ emitdb
@ outcrlf

# 5D
$ 88 + ebp ~ n @ emitdb
$ semicolon  ~ tgtbyte @ outbyte
$ letterp ~ tgtbyte @ outbyte
$ lettero ~ tgtbyte @ outbyte
$ letterp ~ tgtbyte @ outbyte
$ space   ~ tgtbyte @ outbyte
$ lettere ~ tgtbyte @ outbyte
$ letterb ~ tgtbyte @ outbyte
$ letterp ~ tgtbyte @ outbyte
@ outcrlf

# C3
$ 195 ~ n @ emitdb
$ semicolon ~ tgtbyte @ outbyte
@ emitreturn
@ outcrlf

$ 0 ~ ii $ dollar ~ idstring[ii]
$ 1 ~ ii $ dollar ~ idstring[ii]
$ 2 ~ ii $ 0      ~ idstring[ii]
@ searchid
$ csize ~ symvalue[nameindex]

$ nameindex ~ n @ emitid
$ colon  ~ tgtbyte @ outbyte
@ outcrlf

@ emitpgm
$ colon   ~ tgtbyte @ outbyte
@ outcrlf

# 89 86 displ
$ 137 ~ n @ emitdb
$ semicolon ~ tgtbyte @ outbyte
@ emitmov
$ space   ~ tgtbyte @ outbyte
$ lbracket ~ tgtbyte @ outbyte
@ emitesi
$ plus     ~ tgtbyte @ outbyte
$ addrpsystem ~ n @ emitdec
$ rbracket ~ tgtbyte @ outbyte
$ comma   ~ tgtbyte @ outbyte
@ emiteax
@ outcrlf
$ 8 * eax + esi + 128 ~ n @ emitdb
@ outcrlf
$ addrpsystem ~ n @ emitdd
@ outcrlf

!

# =====

: emitpublic

$ letterp ~ tgtbyte @ outbyte
$ letteru ~ tgtbyte @ outbyte
$ letterb ~ tgtbyte @ outbyte
$ letterl ~ tgtbyte @ outbyte
$ letteri ~ tgtbyte @ outbyte
$ letterc ~ tgtbyte @ outbyte
!

# =====

: emitpgm

$ letterp ~ tgtbyte @ outbyte
$ letterg ~ tgtbyte @ outbyte
$ letterm ~ tgtbyte @ outbyte
!

# ===== emit trailer =====

: emittrailer

$ letterc ~ tgtbyte @ outbyte
$ letters ~ tgtbyte @ outbyte
$ letteri ~ tgtbyte @ outbyte
$ letterz ~ tgtbyte @ outbyte
$ lettere ~ tgtbyte @ outbyte
$ space   ~ tgtbyte @ outbyte
$ lettere ~ tgtbyte @ outbyte
$ letterq ~ tgtbyte @ outbyte
$ letteru ~ tgtbyte @ outbyte
$ space   ~ tgtbyte @ outbyte
$ csize ~ n @ emitdec
@ outcrlf

$ semicolon ~ tgtbyte @ outbyte
$ csize ~ n @ emithex
@ outcrlf

$ letterd ~ tgtbyte @ outbyte
$ letters ~ tgtbyte @ outbyte
$ letteri ~ tgtbyte @ outbyte
$ letterz ~ tgtbyte @ outbyte
$ lettere ~ tgtbyte @ outbyte
$ space   ~ tgtbyte @ outbyte
$ lettere ~ tgtbyte @ outbyte
$ letterq ~ tgtbyte @ outbyte
$ letteru ~ tgtbyte @ outbyte
$ space   ~ tgtbyte @ outbyte
$ dsize ~ n @ emitdec
@ outcrlf

$ semicolon ~ tgtbyte @ outbyte
$ dsize ~ n @ emithex
@ outcrlf

$ lettere ~ tgtbyte @ outbyte
$ lettern ~ tgtbyte @ outbyte
$ letterd ~ tgtbyte @ outbyte
@ outcrlf
!

# ===== emit .code =====

: emitcode

$ dot     ~ tgtbyte @ outbyte
$ letterc ~ tgtbyte @ outbyte
$ lettero ~ tgtbyte @ outbyte
$ letterd ~ tgtbyte @ outbyte
$ lettere ~ tgtbyte @ outbyte
!

# ===== emit .data =====

: emitdata

$ dot     ~ tgtbyte @ outbyte
$ letterd ~ tgtbyte @ outbyte
$ lettera ~ tgtbyte @ outbyte
$ lettert ~ tgtbyte @ outbyte
$ lettera ~ tgtbyte @ outbyte
!

# ===== emit mov =====

: emitmov

$ letterm ~ tgtbyte @ outbyte
$ lettero ~ tgtbyte @ outbyte
$ letterv ~ tgtbyte @ outbyte
!

# ===== emit ret =====

: emitreturn

$ letterr ~ tgtbyte @ outbyte
$ lettere ~ tgtbyte @ outbyte
$ lettert ~ tgtbyte @ outbyte
!

# ===== emit cmp =====

: emitcmp

$ letterc ~ tgtbyte @ outbyte
$ letterm ~ tgtbyte @ outbyte
$ letterp ~ tgtbyte @ outbyte
!

# ===== emit set =====

: emitset

$ letters ~ tgtbyte @ outbyte
$ lettere ~ tgtbyte @ outbyte
$ lettert ~ tgtbyte @ outbyte
!

# ===== emit and =====

: emitand

$ lettera ~ tgtbyte @ outbyte
$ lettern ~ tgtbyte @ outbyte
$ letterd ~ tgtbyte @ outbyte
!

# =====

: emitdclvar

$ space   ~ tgtbyte @ outbyte
$ letterd ~ tgtbyte @ outbyte
$ letterd ~ tgtbyte @ outbyte
$ space   ~ tgtbyte @ outbyte
$ query   ~ tgtbyte @ outbyte
!

# =====

: emitoffset

$ lettero ~ tgtbyte @ outbyte
$ letterf ~ tgtbyte @ outbyte
$ letterf ~ tgtbyte @ outbyte
$ letters ~ tgtbyte @ outbyte
$ lettere ~ tgtbyte @ outbyte
$ lettert ~ tgtbyte @ outbyte
!

# =====

: emiteax

$ lettere ~ tgtbyte @ outbyte
$ lettera ~ tgtbyte @ outbyte
$ letterx ~ tgtbyte @ outbyte
!

# =====

: emitecx

$ lettere ~ tgtbyte @ outbyte
$ letterc ~ tgtbyte @ outbyte
$ letterx ~ tgtbyte @ outbyte
!

# =====

: emitedx

$ lettere ~ tgtbyte @ outbyte
$ letterd ~ tgtbyte @ outbyte
$ letterx ~ tgtbyte @ outbyte
!

# =====

: emitesi

$ lettere ~ tgtbyte @ outbyte
$ letters ~ tgtbyte @ outbyte
$ letteri ~ tgtbyte @ outbyte
!

# =====
# ===== byte value is in n, n is destroyed

: emitdb

$ n ~ binval

$ letterd ~ tgtbyte @ outbyte
$ letterb ~ tgtbyte @ outbyte
$ space   ~ tgtbyte @ outbyte
@ emitdec

$ csize + 1 ~ csize

$ binval ~ tgtbyte @ outprebin

!

# =====
# ===== value is in n, n is destroyed

: emitdd

$ n ~ binval

$ letterd ~ tgtbyte @ outbyte
$ letterd ~ tgtbyte @ outbyte
$ space   ~ tgtbyte @ outbyte
@ emitdec

$ csize + 4 ~ csize

$ binval ~ n @ int2hex
$ 0 ~ ii $ 1 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outprebin
$ 2 ~ ii $ 3 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outprebin
$ 4 ~ ii $ 5 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outprebin
$ 6 ~ ii $ 7 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outprebin

!

# =====
# ===== target label index is in n, n is destroyed

: emitlabeldisp

$ n ~ binval

$ letterd ~ tgtbyte @ outbyte
$ letterd ~ tgtbyte @ outbyte
$ space   ~ tgtbyte @ outbyte
@ emitid
$ minus   ~ tgtbyte @ outbyte
$ dollar  ~ tgtbyte @ outbyte
$ minus   ~ tgtbyte @ outbyte
$ zerochar + 4 ~ tgtbyte @ outbyte

$ csize + 4 ~ csize

$ 0 ~ n   # assume forward jump

$ binval = minusone ? skipdisp  # oops, didn't enter after search
$ symvalue[binval] > minusone ? skipdisptable

# undefined, enter information

$ csize - 4 ~ n @ int2hex
$ 0 ~ ii $ 1 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outtbl
$ 2 ~ ii $ 3 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outtbl
$ 4 ~ ii $ 5 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outtbl
$ 6 ~ ii $ 7 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outtbl

$ binval ~ n @ int2hex
$ 0 ~ ii $ 1 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outtbl
$ 2 ~ ii $ 3 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outtbl
$ 4 ~ ii $ 5 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outtbl
$ 6 ~ ii $ 7 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outtbl

: skipdisptable

$ 0 ~ n   # assume forward jump

$ symvalue[binval] ~ binval
$ binval = minusone ? skipdisp

$ binval - csize ~ n  # backward jump, can calculate displacement

: skipdisp

@ int2hex
$ 0 ~ ii $ 1 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outprebin
$ 2 ~ ii $ 3 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outprebin
$ 4 ~ ii $ 5 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outprebin
$ 6 ~ ii $ 7 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outprebin

!

# =====
# ===== name index is in n

: emitid

$ underscore ~ tgtbyte
@ outbyte
$ symname[n] ~ k
: emitidloop
$ namepool[k] ~ tgtbyte
$ tgtbyte = 0 ? exitemitid
@ outbyte
$ k + 1 ~ k
. emitidloop

: exitemitid
!

# ===== write a number in decimal format to the target file =====
# ===== value is in n, n is destroyed

: emitdec

@ int2dec
$ 9 ~ k
$ 10 ~ temp
$ decarray[temp] = 0 ? emitdec01
$ minus ~ tgtbyte @ outbyte
: emitdec01            # skip leading zeros
$ decarray[k] > 0 ? emitdec02
$ k - 1 ~ k
$ k > 0 ? emitdec01    # except the last zero
: emitdec02
$ zerochar + decarray[k] ~ tgtbyte @ outbyte
$ k - 1 ~ k
$ k > minusone ? emitdec02
!

# ===== write a number in hexadecimal format to the target file =====
# ===== value is in n, n is destroyed

: emithex
@ int2hex
$ 7 ~ k
: emithex01
$ hexarray[k] ~ temp
$ hexdigit[temp] ~ tgtbyte @ outbyte
$ k - 1 ~ k
$ k > minusone ? emithex01
!

# ===== finish the raw binary executable

^ loc
^ nextloc
^ nextsymindex

: finishbin

# magic

$ 0 ~ n @ int2hex
$ 0 ~ ii $ 1 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outbin
$ 2 ~ ii $ 3 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outbin
$ 4 ~ ii $ 5 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outbin
$ 6 ~ ii $ 7 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outbin

# header size

$ 16 ~ n @ int2hex
$ 0 ~ ii $ 1 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outbin
$ 2 ~ ii $ 3 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outbin
$ 4 ~ ii $ 5 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outbin
$ 6 ~ ii $ 7 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outbin

# compiler/runtime version

$ 0 * 256 + 0 ~ n
$ 65536 * n ~ n
$ 1 * 256 + 0 + n ~ n
@ int2hex
$ 0 ~ ii $ 1 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outbin
$ 2 ~ ii $ 3 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outbin
$ 4 ~ ii $ 5 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outbin
$ 6 ~ ii $ 7 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outbin

# code size

$ csize ~ n @ int2hex
$ 0 ~ ii $ 1 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outbin
$ 2 ~ ii $ 3 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outbin
$ 4 ~ ii $ 5 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outbin
$ 6 ~ ii $ 7 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outbin

# data size

$ dsize ~ n @ int2hex
$ 0 ~ ii $ 1 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outbin
$ 2 ~ ii $ 3 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outbin
$ 4 ~ ii $ 5 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outbin
$ 6 ~ ii $ 7 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outbin

$ 0 ~ loc
$ minusone ~ nextloc
$ minusone ~ nextsymindex

: finishbin01

@ intbl
$ tgtbyte = minusone ? noentry
        $            tgtbyte           ~ nextloc
@ intbl $ 256      * tgtbyte + nextloc ~ nextloc
@ intbl $ 65536    * tgtbyte + nextloc ~ nextloc
@ intbl $ 16777216 * tgtbyte + nextloc ~ nextloc

@ intbl $            tgtbyte                ~ nextsymindex
@ intbl $ 256      * tgtbyte + nextsymindex ~ nextsymindex
@ intbl $ 65536    * tgtbyte + nextsymindex ~ nextsymindex
@ intbl $ 16777216 * tgtbyte + nextsymindex ~ nextsymindex
: noentry

: finishbin02

@ inprebin
$ tgtbyte = minusone ? bindone

$ loc = nextloc ? fixup

@ outbin

$ loc + 1 ~ loc
. finishbin02

: fixup

# read in rest of filler bytes
@ inprebin
@ inprebin
@ inprebin

$ symvalue[nextsymindex] - loc - 4 ~ n @ int2hex
$ 0 ~ ii $ 1 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outbin
$ 2 ~ ii $ 3 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outbin
$ 4 ~ ii $ 5 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outbin
$ 6 ~ ii $ 7 ~ ii1
$ hexarray[ii1] * 16 + hexarray[ii] ~ tgtbyte @ outbin

$ loc + 4 ~ loc
. finishbin01

: bindone

!

# ===== get one token =====

: gettoken

: testwhite
$ nxtchar = space ? skipwhite
$ nxtchar = tab ? skipwhite
$ nxtchar = cr ? skipwhite
$ nxtchar = lf ? skipwhite
. endwhite
: skipwhite
@ getchar
. testwhite
: endwhite

$ nxtchar = sharp ? skipcomment
$ nxtchar = bang ? singlechartoken
$ nxtchar = dollar ? singlechartoken
$ nxtchar = rparen ? singlechartoken
$ nxtchar = hat ? singlechartoken
$ nxtchar = squiggle ? singlechartoken

$ nxtchar < lettera ? notid
$ nxtchar > letterz ? notid
. getid
: notid

$ nxtchar < zerochar ? notnum
$ nxtchar > ninechar ? notnum
. getnum
: notnum

$ nxtchar ~ nxttoken
@ getchar
!

# =====
: skipcomment
@ getchar
$ nxtchar = cr ? testwhite
$ nxtchar = lf ? testwhite
. skipcomment

# =====
: singlechartoken
$ nxtchar ~ nxttoken
@ getchar
!

# =====
: getnum

$ 0 ~ i
$ 0 ~ nxttokval

: stillnum
$ 10 * nxttokval + nxtchar - zerochar ~ nxttokval
$ i + 1 ~ i
@ getchar
$ nxtchar < zerochar ? endnum
$ nxtchar > ninechar ? endnum
. stillnum
: endnum

$ zerochar ~ nxttoken
!

# =====
: getid

$ 0 ~ i

: stillid
$ nxtchar ~ idstring[i]
$ i + 1 ~ i
@ getchar
$ nxtchar < lettera ? notletter
$ nxtchar > letterz ? notletter
. stillid
: notletter
$ nxtchar < zerochar ? endid
$ nxtchar > ninechar ? endid
. stillid
: endid

$ 0 ~ idstring[i]
$ letteri ~ nxttoken

@ searchid
$ nameindex > minusone ? idfound
@ enterid
: idfound
$ nameindex ~ nxttokval
!

# ===== search for identifier in symbol table =====
# ===== return symbol table index in nameindex, else -1 if not found

: searchid

$ 0 ~ nameindex
: keepsearchingid
@ equalid
$ temp ? searchidfound
$ nameindex + 1 ~ nameindex
$ nameindex < numsym ? keepsearchingid
$ minusone ~ nameindex
: searchidfound
!

# ===== compare symbol table name with last scanned identifier =====
# ===== return 1 if equal, else 0

: equalid

$ 0 ~ idlength
$ symname[nameindex] ~ eqindex
: compareid
$ idstring[idlength] ~ temp
$ temp = namepool[eqindex] ? idstilleq
$ 0 ~ temp
!
: idstilleq
$ idlength + 1 ~ idlength
$ eqindex + 1 ~ eqindex
$ temp > 0 ? compareid
$ 1 ~ temp
!

# ===== create a new identifier in the symbol table =====
# ===== return symbol table index in nameindex

: enterid

$ numsym = numsymmax ? symoverflow

$ numsym ~ nameindex
$ namepoolsize ~ symname[nameindex]
$ minusone ~ symvalue[nameindex]
$ numsym + 1 ~ numsym
$ 0 ~ idlength
: enterid01
$ namepoolsize = namepoolmax ? nameoverflow
$ idstring[idlength] ~ temp
$ temp ~ namepool[namepoolsize]
$ idlength + 1 ~ idlength
$ namepoolsize + 1 ~ namepoolsize
$ temp > 0 ? enterid01
!

: symoverflow
$ star    ~ lstchar @ writechar
$ star    ~ lstchar @ writechar
$ star    ~ lstchar @ writechar
$ space   ~ lstchar @ writechar
$ letters ~ lstchar @ writechar
$ lettery ~ lstchar @ writechar
$ letterm ~ lstchar @ writechar
$ lettero ~ lstchar @ writechar
$ letterf ~ lstchar @ writechar
$ letterl ~ lstchar @ writechar
$ space   ~ lstchar @ writechar
$ lettere ~ lstchar @ writechar
$ letterr ~ lstchar @ writechar
$ letterr ~ lstchar @ writechar
$ lettero ~ lstchar @ writechar
$ letterr ~ lstchar @ writechar
$ space   ~ lstchar @ writechar
$ star    ~ lstchar @ writechar
$ star    ~ lstchar @ writechar
$ star    ~ lstchar @ writechar
@ writecrlf
!
: nameoverflow
$ star    ~ lstchar @ writechar
$ star    ~ lstchar @ writechar
$ star    ~ lstchar @ writechar
$ space   ~ lstchar @ writechar
$ lettern ~ lstchar @ writechar
$ lettera ~ lstchar @ writechar
$ letterm ~ lstchar @ writechar
$ lettero ~ lstchar @ writechar
$ letterf ~ lstchar @ writechar
$ letterl ~ lstchar @ writechar
$ space   ~ lstchar @ writechar
$ lettere ~ lstchar @ writechar
$ letterr ~ lstchar @ writechar
$ letterr ~ lstchar @ writechar
$ lettero ~ lstchar @ writechar
$ letterr ~ lstchar @ writechar
$ space   ~ lstchar @ writechar
$ star    ~ lstchar @ writechar
$ star    ~ lstchar @ writechar
$ star    ~ lstchar @ writechar
@ writecrlf
!

# ===== display symbol table data in the listing =====

: dumpsym
@ writecrlf
@ writecrlf
@ writecrlf
@ writecrlf
$ 0 ~ i
: dumpsym01
$ symvalue[i] ~ n @ writehex
$ space ~ lstchar @ writechar
$ i ~ n @ writename
@ writecrlf
$ i + 1 ~ i
$ i < numsym ? dumpsym01
@ writecrlf
@ writecrlf
!

# ===== write a number in decimal format to the listing =====
# ===== value is in n, n is destroyed

: writedec
@ int2dec
$ 9 ~ k
$ 10 ~ temp
$ decarray[temp] = 0 ? writedec01
$ minus ~ lstchar @ writechar
: writedec01            # skip leading zeros
$ decarray[k] > 0 ? writedec02
$ k - 1 ~ k
$ k > 0 ? writedec01    # except the last zero
: writedec02
$ zerochar + decarray[k] ~ lstchar @ writechar
$ k - 1 ~ k
$ k > minusone ? writedec02
!

# ===== write a number in hexadecimal format to the listing =====
# ===== value is in n, n is destroyed

: writehex
@ int2hex
$ 7 ~ k
: writehex01
$ hexarray[k] ~ temp
$ hexdigit[temp] ~ lstchar @ writechar
$ k - 1 ~ k
$ k > minusone ? writehex01
!

# ===== convert to decimal
# ===== value in n, n destroyed
# ===== return value in decarray, array of decimal digit values (not characters!)

: int2dec
$ 10 ~ temp $ 0 ~ decarray[temp] # sign digit, assume positive
$ n = minvalue ? int2decminvalue
$ n > minusone ? int2decnonnegative
$ 10 ~ temp $ 1 ~ decarray[temp] # sign digit, now it's negative
$ 0 - n ~ n               # absolute value of negative number
: int2decnonnegative
$ 0 ~ k
: int2dec01
$ n / 10 ~ temp           # shift decimal right
$ 10 * temp ~ temp        # shift decimal left
$ n - temp ~ decarray[k]  # get least significant digit
$ n / 10 ~ n
$ k + 1 ~ k
$ k < 10 ? int2dec01
!

# store -2147483648
: int2decminvalue
$ 10 ~ temp $ 1 ~ decarray[temp] # sign digit, minus
$ 9 ~ temp $ 2 ~ decarray[temp]
$ 8 ~ temp $ 1 ~ decarray[temp]
$ 7 ~ temp $ 4 ~ decarray[temp]
$ 6 ~ temp $ 7 ~ decarray[temp]
$ 5 ~ temp $ 4 ~ decarray[temp]
$ 4 ~ temp $ 8 ~ decarray[temp]
$ 3 ~ temp $ 3 ~ decarray[temp]
$ 2 ~ temp $ 6 ~ decarray[temp]
$ 1 ~ temp $ 4 ~ decarray[temp]
$ 0 ~ temp $ 8 ~ decarray[temp]
!

# ===== convert to hexadecimal
# ===== value in n, n destroyed
# ===== return value in hexarray, array of hexadecimal digit values (not characters!)

: int2hex
$ 0 ~ minusflag           # assume positive number
$ n > minusone ? int2hexnonnegative
$ 1 ~ minusflag
$ n - minvalue ~ n        # strip sign bit
: int2hexnonnegative
$ 0 ~ k
: int2hex01
$ n / 16 ~ temp           # shift hex right
$ 16 * temp ~ temp        # shift hex left
$ n - temp ~ hexarray[k]  # get least significant digit
$ n / 16 ~ n
$ k + 1 ~ k
$ k < 8 ? int2hex01
$ minusflag = 0 ? int2hex02
$ 7 ~ temp $ hexarray[temp] + 8 ~ hexarray[temp]  # add back sign bit
: int2hex02
!

# ===== write a symbol table name to the listing =====
# ===== name index is in n

: writename
$ symname[n] ~ k
: writename01
$ namepool[k] = 0 ? writename02
$ namepool[k] ~ lstchar @ writechar
$ k + 1 ~ k
. writename01
: writename02
!

# ===== get one source character and send to listing =====

: getchar

@ readchar

$ nxtchar = minusone ? exitgetchar

$ nxtchar ~ lstchar @ writechar

: exitgetchar
!

# ===== read source character =====
# ===== returns -1 on EOF

: readchar

# read character
$ srcfile ~ sysarg2
$ 4 ~ sysfn
@ system
$ sysarg1 ~ nxtchar
!

# ===== output target byte =====
# in early versions, this is actually a character output

: outbyte

# write character
$ tgtbyte ~ sysarg1
$ tgtfile ~ sysarg2
$ 5 ~ sysfn
@ system
!

: outcrlf

$ cr ~ tgtbyte @ outbyte
$ lf ~ tgtbyte @ outbyte
!

# ===== output intermediate binary file byte =====

: outprebin

# write byte
$ tgtbyte ~ sysarg1
$ prebinfile ~ sysarg2
$ 5 ~ sysfn
@ system
!

# ===== input intermediate binary file byte =====
# ===== returns -1 on EOF

: inprebin

# read byte
$ prebinfile ~ sysarg2
$ 4 ~ sysfn
@ system
$ sysarg1 ~ tgtbyte
!

# ===== output intermediate table file byte

: outtbl

# write byte
$ tgtbyte ~ sysarg1
$ tblfile ~ sysarg2
$ 5 ~ sysfn
@ system
!

# ===== input intermediate table file byte
# ===== returns -1 on EOF

: intbl

# read byte
$ tblfile ~ sysarg2
$ 4 ~ sysfn
@ system
$ sysarg1 ~ tgtbyte
!

# ===== output final binary file byte =====

: outbin

# write byte
$ tgtbyte ~ sysarg1
$ binfile ~ sysarg2
$ 5 ~ sysfn
@ system
!

# ===== write list character =====

: writechar

# write character
$ lstchar ~ sysarg1
$ lstfile ~ sysarg2
$ 5 ~ sysfn
@ system
!

: writecrlf

$ cr ~ lstchar @ writechar
$ lf ~ lstchar @ writechar
!

# ===== error routine =====

: error

$ star    ~ lstchar @ writechar
$ star    ~ lstchar @ writechar
$ star    ~ lstchar @ writechar
$ space   ~ lstchar @ writechar
$ lettere ~ lstchar @ writechar
$ letterr ~ lstchar @ writechar
$ letterr ~ lstchar @ writechar
$ lettero ~ lstchar @ writechar
$ letterr ~ lstchar @ writechar
$ space   ~ lstchar @ writechar
$ star    ~ lstchar @ writechar
$ star    ~ lstchar @ writechar
$ star    ~ lstchar @ writechar
@ writecrlf
!

# ===== parse command line =====
# arguments can always have quotes added,
# so we check for them

^ argtext 4096

: parsecommandline

# get command line
$ 1 ~ sysfn
@ system

$ 0 ~ i
$ sysarray[i] ~ argchar
$ i + 1 ~ i

# get command
@ getargtext

# get first arg
@ getargtext

$ 0 ~ k

: copysfnarg

$ argtext[k] ~ temp
$ temp ~ srcfname[k]
$ k + 1 ~ k

$ temp > 0 ? copysfnarg

# get second arg
@ getargtext

$ 0 ~ k

: copytfnarg

$ argtext[k] ~ temp
$ temp ~ tgtfname[k]
$ k + 1 ~ k

$ temp > 0 ? copytfnarg

# get third arg
@ getargtext

$ 0 ~ k

: copylfnarg

$ argtext[k] ~ temp
$ temp ~ lstfname[k]
$ k + 1 ~ k

$ temp > 0 ? copylfnarg
!

# =====

: getargtext

$ 0 ~ j

: searcharg

$ argchar = space ? cmdskipspace
$ argchar = tab ? cmdskipspace
. getarg

: cmdskipspace

$ sysarray[i] ~ argchar
$ i + 1 ~ i

. searcharg

# ===

: getarg

$ argchar = quote ? getquotedarg

: getarga

$ argchar = space ? endarg
$ argchar = tab ? endarg
$ argchar = 0 ? endarg

$ argchar ~ argtext[j]
$ j + 1 ~ j

$ sysarray[i] ~ argchar
$ i + 1 ~ i

. getarga

# ===

: getquotedarg

# skip opening quote
$ sysarray[i] ~ argchar
$ i + 1 ~ i

: getquotedarga

$ argchar = quote ? endquotedarg
$ argchar = 0 ? endarg

$ argchar ~ argtext[j]
$ j + 1 ~ j

$ sysarray[i] ~ argchar 
$ i + 1 ~ i

. getquotedarga

: endquotedarg

# skip closing quote
$ sysarray[i] ~ argchar 
$ i + 1 ~ i

# ===

: endarg

$ 0 ~ argtext[j]
!